import cv2
from PIL import Image
import os


FILE_NAME = "./video.mp4"


def initialize():
    os.mkdir("ba1/functions")
    os.mkdir("ba1/blocks")
    os.mkdir("image")


def getVideoFrames(filename,lc):
    cap = cv2.VideoCapture(filename)
    count = 0
    coun = 0
    while(cap.isOpened()):
        ret, frame = cap.read()
        if not ret:
            break
        resized = cv2.resize(frame, (100,75),cv2.INTER_CUBIC)
        coun += 1
        if(coun % lc == 0):
            cv2.imwrite("./image" + "/" + str(count) + ".jpg", resized)
            count = count + 1
    cap.release()
    return int(coun / lc)


def generateBlocks():
    JSON1 = '''{"format_version": "1.10.0","minecraft:block": {"description": {"identifier": "rgb:a'''
    JSON2 = '''","is_experimental": false}}}'''
    y = 0
    for i in range(0,11):
        for j in range(0,11):
            for k in range(0,11):
                i2,j2,k3 = round(i/10.0,1),round(j/10.0,1),round(k/10.0,1)
                file = open('./ba1/blocks/' + 'rgb' + str(y) + '.json','w')
                file.write(JSON1 + str(i2) + "_" + str(j2) + "_" + str(k3) + JSON2)
                y += 1


def generateFunctions(allin):
    for i in range(0,allin):
        file = open('./ba1/functions/' + 'ba' + str(i) + '.mcfunction','w')
        im = Image.open('./image/' + str(i) + ".jpg").convert('RGB')
        if(i == 0):
            for j in range(-50,50):
                for k in range(-38,37):
                    r, g, b = im.getpixel((j+50, k+38))
                    file.write("setblock " 
                                + str(j) + " -50 " + str(k) + " rgb:a" 
                                + str(round(r/255.0,1)) + "_" 
                                + str(round(g/255.0,1)) + "_" 
                                + str(round(b/255.0,1)) + "\n")
        else:
            im2 = Image.open('./image/' + str(i-1) + ".jpg").convert('RGB')
            for j in range(-50,50):
                for k in range(-38,37):
                    r, g, b  = im.getpixel((j+50, k+38))
                    r2,g2,b2 = im2.getpixel((j+50, k+38))
                    if(r == r2 and g == g2 and b == b2):
                        file.write("setblock " + str(j) + " -51 " + str(k) + " air\n")
                    else:
                        file.write("setblock " 
                                    + str(j) + " -50 " + str(k) + " rgb:a" 
                                    + str(round(r/255.0,1)) + "_" 
                                    + str(round(g/255.0,1)) + "_" 
                                    + str(round(b/255.0,1)) + "\n")
    file.close()


if __name__ == "__main__":
    initialize()
    generateBlocks()
    allinframe = getVideoFrames(FILE_NAME,2)
    generateFunctions(allinframe)